// kafka-connector options: START
[[camel-debezium-sqlserver-kafka-connector-source]]
= camel-debezium-sqlserver-kafka-connector source configuration

When using camel-debezium-sqlserver-kafka-connector as source make sure to use the following Maven dependency to have support for the connector:

[source,xml]
----
<dependency>
  <groupId>org.apache.camel.kafkaconnector</groupId>
  <artifactId>camel-debezium-sqlserver-kafka-connector</artifactId>
  <version>x.x.x</version>
  <!-- use the same version as your Camel Kafka connector version -->
</dependency>
----

To use this Source connector in Kafka connect you'll need to set the following connector.class

[source,java]
----
connector.class=org.apache.camel.kafkaconnector.debeziumsqlserver.CamelDebeziumsqlserverSourceConnector
----


The camel-debezium-sqlserver source connector supports 99 options, which are listed below.



[width="100%",cols="2,5,^1,2",options="header"]
|===
| Name | Description | Default | Priority
| *camel.source.path.name* | Unique name for the connector. Attempting to register again with the same name will fail. | null | HIGH
| *camel.source.endpoint.additionalProperties* | Additional properties for debezium components in case they can't be set directly on the camel configurations (e.g: setting Kafka Connect properties needed by Debezium engine, for example setting KafkaOffsetBackingStore), the properties have to be prefixed with additionalProperties.. E.g: additionalProperties.transactional.id=12345&additionalProperties.schema.registry.url=\http://localhost:8811/avro | null | MEDIUM
| *camel.source.endpoint.bridgeErrorHandler* | Allows for bridging the consumer to the Camel routing Error Handler, which mean any exceptions occurred while the consumer is trying to pickup incoming messages, or the likes, will now be processed as a message and handled by the routing Error Handler. By default the consumer will use the org.apache.camel.spi.ExceptionHandler to deal with exceptions, that will be logged at WARN or ERROR level and ignored. | false | MEDIUM
| *camel.source.endpoint.internalKeyConverter* | The Converter class that should be used to serialize and deserialize key data for offsets. The default is JSON converter. | "org.apache.kafka.connect.json.JsonConverter" | MEDIUM
| *camel.source.endpoint.internalValueConverter* | The Converter class that should be used to serialize and deserialize value data for offsets. The default is JSON converter. | "org.apache.kafka.connect.json.JsonConverter" | MEDIUM
| *camel.source.endpoint.offsetCommitPolicy* | The name of the Java class of the commit policy. It defines when offsets commit has to be triggered based on the number of events processed and the time elapsed since the last commit. This class must implement the interface 'OffsetCommitPolicy'. The default is a periodic commit policy based upon time intervals. | "io.debezium.embedded.spi.OffsetCommitPolicy.PeriodicCommitOffsetPolicy" | MEDIUM
| *camel.source.endpoint.offsetCommitTimeoutMs* | Maximum number of milliseconds to wait for records to flush and partition offset data to be committed to offset storage before cancelling the process and restoring the offset data to be committed in a future attempt. The default is 5 seconds. | 5000L | MEDIUM
| *camel.source.endpoint.offsetFlushIntervalMs* | Interval at which to try committing offsets. The default is 1 minute. | 60000L | MEDIUM
| *camel.source.endpoint.offsetStorage* | The name of the Java class that is responsible for persistence of connector offsets. | "org.apache.kafka.connect.storage.FileOffsetBackingStore" | MEDIUM
| *camel.source.endpoint.offsetStorageFileName* | Path to file where offsets are to be stored. Required when offset.storage is set to the FileOffsetBackingStore. | null | MEDIUM
| *camel.source.endpoint.offsetStoragePartitions* | The number of partitions used when creating the offset storage topic. Required when offset.storage is set to the 'KafkaOffsetBackingStore'. | null | MEDIUM
| *camel.source.endpoint.offsetStorageReplication Factor* | Replication factor used when creating the offset storage topic. Required when offset.storage is set to the KafkaOffsetBackingStore | null | MEDIUM
| *camel.source.endpoint.offsetStorageTopic* | The name of the Kafka topic where offsets are to be stored. Required when offset.storage is set to the KafkaOffsetBackingStore. | null | MEDIUM
| *camel.source.endpoint.exceptionHandler* | To let the consumer use a custom ExceptionHandler. Notice if the option bridgeErrorHandler is enabled then this option is not in use. By default the consumer will deal with exceptions, that will be logged at WARN or ERROR level and ignored. | null | MEDIUM
| *camel.source.endpoint.exchangePattern* | Sets the exchange pattern when the consumer creates an exchange. One of: [InOnly] [InOut] [InOptionalOut] | null | MEDIUM
| *camel.source.endpoint.basicPropertyBinding* | Whether the endpoint should use basic property binding (Camel 2.x) or the newer property binding with additional capabilities | false | MEDIUM
| *camel.source.endpoint.synchronous* | Sets whether synchronous processing should be strictly used, or Camel is allowed to use asynchronous processing (if supported). | false | MEDIUM
| *camel.source.endpoint.columnBlacklist* | Description is not available here, please check Debezium website for corresponding key 'column.blacklist' description. | null | MEDIUM
| *camel.source.endpoint.databaseDbname* | The name of the database the connector should be monitoring. When working with a multi-tenant set-up, must be set to the CDB name. | null | MEDIUM
| *camel.source.endpoint.databaseHistory* | The name of the DatabaseHistory class that should be used to store and recover database schema changes. The configuration properties for the history are prefixed with the 'database.history.' string. | "io.debezium.relational.history.FileDatabaseHistory" | MEDIUM
| *camel.source.endpoint.databaseHistoryFileFilename* | The path to the file that will be used to record the database history | null | MEDIUM
| *camel.source.endpoint.databaseHistoryKafka BootstrapServers* | A list of host/port pairs that the connector will use for establishing the initial connection to the Kafka cluster for retrieving database schema history previously stored by the connector. This should point to the same Kafka cluster used by the Kafka Connect process. | null | MEDIUM
| *camel.source.endpoint.databaseHistoryKafkaRecovery Attempts* | The number of attempts in a row that no data are returned from Kafka before recover completes. The maximum amount of time to wait after receiving no data is (recovery.attempts) x (recovery.poll.interval.ms). | 100 | MEDIUM
| *camel.source.endpoint.databaseHistoryKafkaRecovery PollIntervalMs* | The number of milliseconds to wait while polling for persisted data during recovery. | 100 | MEDIUM
| *camel.source.endpoint.databaseHistoryKafkaTopic* | The name of the topic for the database schema history | null | MEDIUM
| *camel.source.endpoint.databaseHostname* | Resolvable hostname or IP address of the SQL Server database server. | null | MEDIUM
| *camel.source.endpoint.databasePassword* | Password of the SQL Server database user to be used when connecting to the database. | null | HIGH
| *camel.source.endpoint.databasePort* | Port of the SQL Server database server. | 1433 | MEDIUM
| *camel.source.endpoint.databaseServerName* | Unique name that identifies the database server and all recorded offsets, and that is used as a prefix for all schemas and topics. Each distinct installation should have a separate namespace and be monitored by at most one Debezium connector. | null | HIGH
| *camel.source.endpoint.databaseServerTimezone* | The timezone of the server used to correctly shift the commit transaction timestamp on the client sideOptions include: Any valid Java ZoneId | null | MEDIUM
| *camel.source.endpoint.databaseUser* | Name of the SQL Server database user to be used when connecting to the database. | null | MEDIUM
| *camel.source.endpoint.decimalHandlingMode* | Specify how DECIMAL and NUMERIC columns should be represented in change events, including:'precise' (the default) uses java.math.BigDecimal to represent values, which are encoded in the change events using a binary representation and Kafka Connect's 'org.apache.kafka.connect.data.Decimal' type; 'string' uses string to represent values; 'double' represents values using Java's 'double', which may not offer the precision but will be far easier to use in consumers. | "precise" | MEDIUM
| *camel.source.endpoint.eventProcessingFailure HandlingMode* | Specify how failures during processing of events (i.e. when encountering a corrupted event) should be handled, including:'fail' (the default) an exception indicating the problematic event and its position is raised, causing the connector to be stopped; 'warn' the problematic event and its position will be logged and the event will be skipped;'ignore' the problematic event will be skipped. | "fail" | MEDIUM
| *camel.source.endpoint.heartbeatIntervalMs* | Length of an interval in milli-seconds in in which the connector periodically sends heartbeat messages to a heartbeat topic. Use 0 to disable heartbeat messages. Disabled by default. | 0 | MEDIUM
| *camel.source.endpoint.heartbeatTopicsPrefix* | The prefix that is used to name heartbeat topics.Defaults to __debezium-heartbeat. | "__debezium-heartbeat" | MEDIUM
| *camel.source.endpoint.maxBatchSize* | Maximum size of each batch of source records. Defaults to 2048. | 2048 | MEDIUM
| *camel.source.endpoint.maxQueueSize* | Maximum size of the queue for change events read from the database log but not yet recorded or forwarded. Defaults to 8192, and should always be larger than the maximum batch size. | 8192 | MEDIUM
| *camel.source.endpoint.messageKeyColumns* | A semicolon-separated list of expressions that match fully-qualified tables and column(s) to be used as message key. Each expression must match the pattern ':',where the table names could be defined as (DB_NAME.TABLE_NAME) or (SCHEMA_NAME.TABLE_NAME), depending on the specific connector,and the key columns are a comma-separated list of columns representing the custom key. For any table without an explicit key configuration the table's primary key column(s) will be used as message key.Example: dbserver1.inventory.orderlines:orderId,orderLineId;dbserver1.inventory.orders:id | null | MEDIUM
| *camel.source.endpoint.pollIntervalMs* | Frequency in milliseconds to wait for new change events to appear after receiving no events. Defaults to 500ms. | 500L | MEDIUM
| *camel.source.endpoint.provideTransactionMetadata* | Enables transaction metadata extraction together with event counting | false | MEDIUM
| *camel.source.endpoint.snapshotDelayMs* | The number of milliseconds to delay before a snapshot will begin. | 0L | MEDIUM
| *camel.source.endpoint.snapshotFetchSize* | The maximum number of records that should be loaded into memory while performing a snapshot | null | MEDIUM
| *camel.source.endpoint.snapshotLockTimeoutMs* | The maximum number of millis to wait for table locks at the beginning of a snapshot. If locks cannot be acquired in this time frame, the snapshot will be aborted. Defaults to 10 seconds | 10000L | MEDIUM
| *camel.source.endpoint.snapshotMode* | The criteria for running a snapshot upon startup of the connector. Options include: 'initial' (the default) to specify the connector should run a snapshot only when no offsets are available for the logical server name; 'schema_only' to specify the connector should run a snapshot of the schema when no offsets are available for the logical server name. | "initial" | MEDIUM
| *camel.source.endpoint.snapshotSelectStatement Overrides* | This property contains a comma-separated list of fully-qualified tables (DB_NAME.TABLE_NAME) or (SCHEMA_NAME.TABLE_NAME), depending on thespecific connectors . Select statements for the individual tables are specified in further configuration properties, one for each table, identified by the id 'snapshot.select.statement.overrides.DB_NAME.TABLE_NAME' or 'snapshot.select.statement.overrides.SCHEMA_NAME.TABLE_NAME', respectively. The value of those properties is the select statement to use when retrieving data from the specific table during snapshotting. A possible use case for large append-only tables is setting a specific point where to start (resume) snapshotting, in case a previous snapshotting was interrupted. | null | MEDIUM
| *camel.source.endpoint.sourceStructVersion* | A version of the format of the publicly visible source part in the message | "v2" | MEDIUM
| *camel.source.endpoint.tableBlacklist* | Description is not available here, please check Debezium website for corresponding key 'table.blacklist' description. | null | MEDIUM
| *camel.source.endpoint.tableIgnoreBuiltin* | Flag specifying whether built-in tables should be ignored. | true | MEDIUM
| *camel.source.endpoint.tableWhitelist* | The tables for which changes are to be captured | null | MEDIUM
| *camel.source.endpoint.timePrecisionMode* | Time, date, and timestamps can be represented with different kinds of precisions, including:'adaptive' (the default) bases the precision of time, date, and timestamp values on the database column's precision; 'adaptive_time_microseconds' like 'adaptive' mode, but TIME fields always use microseconds precision;'connect' always represents time, date, and timestamp values using Kafka Connect's built-in representations for Time, Date, and Timestamp, which uses millisecond precision regardless of the database columns' precision . | "adaptive" | MEDIUM
| *camel.source.endpoint.tombstonesOnDelete* | Whether delete operations should be represented by a delete event and a subsquenttombstone event (true) or only by a delete event (false). Emitting the tombstone event (the default behavior) allows Kafka to completely delete all events pertaining to the given key once the source record got deleted. | false | MEDIUM
| *camel.component.debezium-sqlserver.additional Properties* | Additional properties for debezium components in case they can't be set directly on the camel configurations (e.g: setting Kafka Connect properties needed by Debezium engine, for example setting KafkaOffsetBackingStore), the properties have to be prefixed with additionalProperties.. E.g: additionalProperties.transactional.id=12345&additionalProperties.schema.registry.url=\http://localhost:8811/avro | null | MEDIUM
| *camel.component.debezium-sqlserver.bridgeError Handler* | Allows for bridging the consumer to the Camel routing Error Handler, which mean any exceptions occurred while the consumer is trying to pickup incoming messages, or the likes, will now be processed as a message and handled by the routing Error Handler. By default the consumer will use the org.apache.camel.spi.ExceptionHandler to deal with exceptions, that will be logged at WARN or ERROR level and ignored. | false | MEDIUM
| *camel.component.debezium-sqlserver.configuration* | Allow pre-configured Configurations to be set. | null | MEDIUM
| *camel.component.debezium-sqlserver.internalKey Converter* | The Converter class that should be used to serialize and deserialize key data for offsets. The default is JSON converter. | "org.apache.kafka.connect.json.JsonConverter" | MEDIUM
| *camel.component.debezium-sqlserver.internalValue Converter* | The Converter class that should be used to serialize and deserialize value data for offsets. The default is JSON converter. | "org.apache.kafka.connect.json.JsonConverter" | MEDIUM
| *camel.component.debezium-sqlserver.offsetCommit Policy* | The name of the Java class of the commit policy. It defines when offsets commit has to be triggered based on the number of events processed and the time elapsed since the last commit. This class must implement the interface 'OffsetCommitPolicy'. The default is a periodic commit policy based upon time intervals. | "io.debezium.embedded.spi.OffsetCommitPolicy.PeriodicCommitOffsetPolicy" | MEDIUM
| *camel.component.debezium-sqlserver.offsetCommit TimeoutMs* | Maximum number of milliseconds to wait for records to flush and partition offset data to be committed to offset storage before cancelling the process and restoring the offset data to be committed in a future attempt. The default is 5 seconds. | 5000L | MEDIUM
| *camel.component.debezium-sqlserver.offsetFlush IntervalMs* | Interval at which to try committing offsets. The default is 1 minute. | 60000L | MEDIUM
| *camel.component.debezium-sqlserver.offsetStorage* | The name of the Java class that is responsible for persistence of connector offsets. | "org.apache.kafka.connect.storage.FileOffsetBackingStore" | MEDIUM
| *camel.component.debezium-sqlserver.offsetStorage FileName* | Path to file where offsets are to be stored. Required when offset.storage is set to the FileOffsetBackingStore. | null | MEDIUM
| *camel.component.debezium-sqlserver.offsetStorage Partitions* | The number of partitions used when creating the offset storage topic. Required when offset.storage is set to the 'KafkaOffsetBackingStore'. | null | MEDIUM
| *camel.component.debezium-sqlserver.offsetStorage ReplicationFactor* | Replication factor used when creating the offset storage topic. Required when offset.storage is set to the KafkaOffsetBackingStore | null | MEDIUM
| *camel.component.debezium-sqlserver.offsetStorage Topic* | The name of the Kafka topic where offsets are to be stored. Required when offset.storage is set to the KafkaOffsetBackingStore. | null | MEDIUM
| *camel.component.debezium-sqlserver.basicProperty Binding* | Whether the component should use basic property binding (Camel 2.x) or the newer property binding with additional capabilities | false | MEDIUM
| *camel.component.debezium-sqlserver.columnBlacklist* | Description is not available here, please check Debezium website for corresponding key 'column.blacklist' description. | null | MEDIUM
| *camel.component.debezium-sqlserver.databaseDbname* | The name of the database the connector should be monitoring. When working with a multi-tenant set-up, must be set to the CDB name. | null | MEDIUM
| *camel.component.debezium-sqlserver.databaseHistory* | The name of the DatabaseHistory class that should be used to store and recover database schema changes. The configuration properties for the history are prefixed with the 'database.history.' string. | "io.debezium.relational.history.FileDatabaseHistory" | MEDIUM
| *camel.component.debezium-sqlserver.databaseHistory FileFilename* | The path to the file that will be used to record the database history | null | MEDIUM
| *camel.component.debezium-sqlserver.databaseHistory KafkaBootstrapServers* | A list of host/port pairs that the connector will use for establishing the initial connection to the Kafka cluster for retrieving database schema history previously stored by the connector. This should point to the same Kafka cluster used by the Kafka Connect process. | null | MEDIUM
| *camel.component.debezium-sqlserver.databaseHistory KafkaRecoveryAttempts* | The number of attempts in a row that no data are returned from Kafka before recover completes. The maximum amount of time to wait after receiving no data is (recovery.attempts) x (recovery.poll.interval.ms). | 100 | MEDIUM
| *camel.component.debezium-sqlserver.databaseHistory KafkaRecoveryPollIntervalMs* | The number of milliseconds to wait while polling for persisted data during recovery. | 100 | MEDIUM
| *camel.component.debezium-sqlserver.databaseHistory KafkaTopic* | The name of the topic for the database schema history | null | MEDIUM
| *camel.component.debezium-sqlserver.database Hostname* | Resolvable hostname or IP address of the SQL Server database server. | null | MEDIUM
| *camel.component.debezium-sqlserver.database Password* | Password of the SQL Server database user to be used when connecting to the database. | null | HIGH
| *camel.component.debezium-sqlserver.databasePort* | Port of the SQL Server database server. | 1433 | MEDIUM
| *camel.component.debezium-sqlserver.databaseServer Name* | Unique name that identifies the database server and all recorded offsets, and that is used as a prefix for all schemas and topics. Each distinct installation should have a separate namespace and be monitored by at most one Debezium connector. | null | HIGH
| *camel.component.debezium-sqlserver.databaseServer Timezone* | The timezone of the server used to correctly shift the commit transaction timestamp on the client sideOptions include: Any valid Java ZoneId | null | MEDIUM
| *camel.component.debezium-sqlserver.databaseUser* | Name of the SQL Server database user to be used when connecting to the database. | null | MEDIUM
| *camel.component.debezium-sqlserver.decimalHandling Mode* | Specify how DECIMAL and NUMERIC columns should be represented in change events, including:'precise' (the default) uses java.math.BigDecimal to represent values, which are encoded in the change events using a binary representation and Kafka Connect's 'org.apache.kafka.connect.data.Decimal' type; 'string' uses string to represent values; 'double' represents values using Java's 'double', which may not offer the precision but will be far easier to use in consumers. | "precise" | MEDIUM
| *camel.component.debezium-sqlserver.eventProcessing FailureHandlingMode* | Specify how failures during processing of events (i.e. when encountering a corrupted event) should be handled, including:'fail' (the default) an exception indicating the problematic event and its position is raised, causing the connector to be stopped; 'warn' the problematic event and its position will be logged and the event will be skipped;'ignore' the problematic event will be skipped. | "fail" | MEDIUM
| *camel.component.debezium-sqlserver.heartbeat IntervalMs* | Length of an interval in milli-seconds in in which the connector periodically sends heartbeat messages to a heartbeat topic. Use 0 to disable heartbeat messages. Disabled by default. | 0 | MEDIUM
| *camel.component.debezium-sqlserver.heartbeatTopics Prefix* | The prefix that is used to name heartbeat topics.Defaults to __debezium-heartbeat. | "__debezium-heartbeat" | MEDIUM
| *camel.component.debezium-sqlserver.maxBatchSize* | Maximum size of each batch of source records. Defaults to 2048. | 2048 | MEDIUM
| *camel.component.debezium-sqlserver.maxQueueSize* | Maximum size of the queue for change events read from the database log but not yet recorded or forwarded. Defaults to 8192, and should always be larger than the maximum batch size. | 8192 | MEDIUM
| *camel.component.debezium-sqlserver.messageKey Columns* | A semicolon-separated list of expressions that match fully-qualified tables and column(s) to be used as message key. Each expression must match the pattern ':',where the table names could be defined as (DB_NAME.TABLE_NAME) or (SCHEMA_NAME.TABLE_NAME), depending on the specific connector,and the key columns are a comma-separated list of columns representing the custom key. For any table without an explicit key configuration the table's primary key column(s) will be used as message key.Example: dbserver1.inventory.orderlines:orderId,orderLineId;dbserver1.inventory.orders:id | null | MEDIUM
| *camel.component.debezium-sqlserver.pollIntervalMs* | Frequency in milliseconds to wait for new change events to appear after receiving no events. Defaults to 500ms. | 500L | MEDIUM
| *camel.component.debezium-sqlserver.provide TransactionMetadata* | Enables transaction metadata extraction together with event counting | false | MEDIUM
| *camel.component.debezium-sqlserver.snapshotDelayMs* | The number of milliseconds to delay before a snapshot will begin. | 0L | MEDIUM
| *camel.component.debezium-sqlserver.snapshotFetch Size* | The maximum number of records that should be loaded into memory while performing a snapshot | null | MEDIUM
| *camel.component.debezium-sqlserver.snapshotLock TimeoutMs* | The maximum number of millis to wait for table locks at the beginning of a snapshot. If locks cannot be acquired in this time frame, the snapshot will be aborted. Defaults to 10 seconds | 10000L | MEDIUM
| *camel.component.debezium-sqlserver.snapshotMode* | The criteria for running a snapshot upon startup of the connector. Options include: 'initial' (the default) to specify the connector should run a snapshot only when no offsets are available for the logical server name; 'schema_only' to specify the connector should run a snapshot of the schema when no offsets are available for the logical server name. | "initial" | MEDIUM
| *camel.component.debezium-sqlserver.snapshotSelect StatementOverrides* | This property contains a comma-separated list of fully-qualified tables (DB_NAME.TABLE_NAME) or (SCHEMA_NAME.TABLE_NAME), depending on thespecific connectors . Select statements for the individual tables are specified in further configuration properties, one for each table, identified by the id 'snapshot.select.statement.overrides.DB_NAME.TABLE_NAME' or 'snapshot.select.statement.overrides.SCHEMA_NAME.TABLE_NAME', respectively. The value of those properties is the select statement to use when retrieving data from the specific table during snapshotting. A possible use case for large append-only tables is setting a specific point where to start (resume) snapshotting, in case a previous snapshotting was interrupted. | null | MEDIUM
| *camel.component.debezium-sqlserver.sourceStruct Version* | A version of the format of the publicly visible source part in the message | "v2" | MEDIUM
| *camel.component.debezium-sqlserver.tableBlacklist* | Description is not available here, please check Debezium website for corresponding key 'table.blacklist' description. | null | MEDIUM
| *camel.component.debezium-sqlserver.tableIgnore Builtin* | Flag specifying whether built-in tables should be ignored. | true | MEDIUM
| *camel.component.debezium-sqlserver.tableWhitelist* | The tables for which changes are to be captured | null | MEDIUM
| *camel.component.debezium-sqlserver.timePrecision Mode* | Time, date, and timestamps can be represented with different kinds of precisions, including:'adaptive' (the default) bases the precision of time, date, and timestamp values on the database column's precision; 'adaptive_time_microseconds' like 'adaptive' mode, but TIME fields always use microseconds precision;'connect' always represents time, date, and timestamp values using Kafka Connect's built-in representations for Time, Date, and Timestamp, which uses millisecond precision regardless of the database columns' precision . | "adaptive" | MEDIUM
| *camel.component.debezium-sqlserver.tombstonesOn Delete* | Whether delete operations should be represented by a delete event and a subsquenttombstone event (true) or only by a delete event (false). Emitting the tombstone event (the default behavior) allows Kafka to completely delete all events pertaining to the given key once the source record got deleted. | false | MEDIUM
|===
// kafka-connector options: END
